<!DOCTYPE html>
<!--
    (c) Copyright 2020 CERN for the benefit of the LHCb Collaboration

    This software is distributed under the terms of the GNU General Public
    Licence version 3 (GPL Version 3), copied verbatim in the file "COPYING".

    In applying this licence, CERN does not waive the privileges and immunities
    granted to it by virtue of its status as an Intergovernmental Organization
    or submit itself to any jurisdiction.
-->
<html>
<head>
  <meta charset="utf-8"/>

  <link href="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/themes/prism.css" rel="stylesheet" />
  <link href="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/themes/prism-okaidia.css" rel="stylesheet" />
  {#- Plugins #}
  <link href="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/plugins/line-numbers/prism-line-numbers.css" rel="stylesheet" />
  <link href="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/plugins/toolbar/prism-toolbar.css" rel="stylesheet" />

  <link href="/static/analysis-productions.css" rel="stylesheet" />
  <script src="/static/analysis-productions.js"></script>

  <style>
    @namespace xlink 'http://www.w3.org/1999/xlink';

{% for production in pipeline.productions -%}
  {%- for job in production.jobs %}
    {%- set status_colour, status_colour_hover = {
        TestStatusEnum.RUNNING: ('#8888ff', '#ccccff'),
        TestStatusEnum.SUCCESS: ('#88ff88', '#ccffcc'),
        TestStatusEnum.FAILED: ('#ff8888', '#ffcccc'),
        TestStatusEnum.UNKNOWN: ('#ffff88', '#ffffcc'),
      }[job.tests[-1].status if job.tests else TestStatusEnum.UNKNOWN]
      %}
      /*TestStatusEnum.UNKNOWN*/
    a[xlink|href="{{ production.name }}/{{ job.name }}"] polygon {
    fill: {{ status_colour }};
    }
    a[xlink|href="{{ production.name }}/{{ job.name }}"]:hover polygon {
    fill: {{ status_colour_hover }};
    }
  {%- endfor %}
{%- endfor %}
  </style>
</head>
<body class="line-numbers" data-toolbar-order="log-filters,copy-to-clipboard,select-code,download-file">

<h2>Analysis production for pipeline <a href="{{ pipeline.job.pipeline_url }}">#{{ pipeline.id }}</a></h2>

{% for production in pipeline.productions|sort(attribute='id') -%}
<h1 id="{{ production.name }}" class="mono-text">{{ production.name }}</h1>

<p>
  <b>Commit:</b>
    <a href="{{ pipeline.job.pipeline_url }}">{{ pipeline.job.commit_sha[:8] }}</a> <br>
  <b>Message:</b>
    {{ pipeline.job.commit_message }} <br>
  <b>Colour code:</b>
    <span class="job-status-running">Running</span>
    <span class="job-status-success">Success</span>
    <span class="job-status-failed">Failed</span>
    <span class="job-status-unknown">Unknown</span>
</p>

<h3>Raw YAML<span id="toggle-raw-yaml-{{loop.index}}" class="display-button">Show</span></h3>
<a class="view-text-file-fallback" href="/dynamic/{{ pipeline.id }}/{{ production.name }}/raw.yaml">raw.yaml</a>
<div id="raw-yaml-{{loop.index}}">
  <pre class="language-j2yaml"
       data-src="/dynamic/{{ pipeline.id }}/{{ production.name }}/raw.yaml"
       data-download-link data-download-link-label="Download"></pre>
</div>

<h3>Rendered YAML<span id="toggle-rendered-yaml-{{loop.index}}" class="display-button">Show</span></h3>
<a class="view-text-file-fallback" href="/dynamic/{{ pipeline.id }}/{{ production.name }}/rendered.yaml">rendered.yaml</a>
<div id="rendered-yaml-{{loop.index}}">
  <pre class="language-yaml"
       data-src="/dynamic/{{ pipeline.id }}/{{ production.name }}/rendered.yaml"
       data-download-link data-download-link-label="Download"></pre>
</div>

<p>
  Click on a job for more information
</p>

{{ production.svg }}

<table id="results-summary-table">
  <col>
  <colgroup span="3"></colgroup>
  <colgroup span="3"></colgroup>
  <colgroup span="2"></colgroup>
  <tr>
    <th rowspan="2">Job Name</th>
    <th colspan="3" scope="colgroup">Test job statistics</th>
    <th colspan="3" scope="colgroup">Log messages</th>
    <th colspan="2" scope="colgroup">Estimated total</th>
  </tr>

  <tr>
    <th>Events</th>
    <th>Runtime</th>
    <th>Size</th>
    <th class="token warning">Warn</th>
    <th class="token error">Error</th>
    <th class="token fatal">Fatal</th>
    <th>Size</th>
    <th>Kept</th>
  </tr>

{%- for job in production.jobs|sort(attribute='name') %}
  <tr class="job-status-{{ job.tests[-1].status.name|lower if job.tests else 'unknown' }}" onclick="window.location='{{ production.name }}/{{ job.name }}';">
    <td class="mono-text">{{ job.name }}</td>

  {%- if job.tests %}
    <td>{{ job.tests[-1].events_processed }}</td>
    <td>{{ in_hours(job.tests[-1].run_time, job.tests[-1].cpu_norm) }}</td>
    <td>
      {%- for output_file in job.tests[-1].output_files %}
        {{- in_mb(output_file.size) }}{% if not loop.last %} + {% endif %}
      {%- endfor -%}
    </td>

    <td {% if job.tests[-1].n_log_warning -%} class="bold-text token warning" {%- endif %}>{{ job.tests[-1].n_log_warning }}</td>
    <td {% if job.tests[-1].n_log_error -%} class="bold-text token error" {%- endif %}>{{ job.tests[-1].n_log_error }}</td>
    <td {% if job.tests[-1].n_log_fatal -%} class="bold-text token fatal" {%- endif %}>{{ job.tests[-1].n_log_fatal }}</td>

    <td>
      {%- for output_file in job.tests[-1].output_files %}
        {{- in_gb(output_file.dataset_size) }}{% if not loop.last %} + {% endif %}
      {%- endfor -%}
    </td>
  {%- else -%}
    <td></td>
    <td></td>
    <td></td>
    <td></td>
    <td></td>
    <td></td>
    <td></td>
  {%- endif -%}
    <td class="job-data-kept-{{ job.keep_output|lower }}">{{ job.keep_output }}</td>
  </tr>
{%- endfor %}
</table>
{%- endfor %}

<footer>
  <p>For support see the <a href="https://mattermost.web.cern.ch/lhcb/channels/dpa-wp2-analysis-productions">DPA WP2 Analysis Productions</a> channel on mattermost.</p>
  <p>{{ version_string }}</p>
</footer>

<script src="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/prism.js"></script>
{# Languages -#}
<script src="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/components/prism-bash.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/components/prism-yaml.js"></script>
{# Plugins -#}
<script src="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/plugins/line-numbers/prism-line-numbers.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/plugins/toolbar/prism-toolbar.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/clipboard.js/2.0.4/clipboard.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/plugins/copy-to-clipboard/prism-copy-to-clipboard.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/plugins/normalize-whitespace/prism-normalize-whitespace.js"></script>
{# Customisations -#}
<script src="/static/prism-gaudirunlog.js"></script>
<script src="/static/prism-lang-j2yaml.js"></script>
<script src="/static/prism-toolbar.js"></script>
</body>
</html>
